import pygame
import os

pygame.init()

class SpriteAnimated:
    def __init__(self, pos, milli=200):
        
        self.x = pos[0] 
        self.y = pos[1]

        
        self.frames = {}
        self.key = 'front'
        self.frame = 0
        
        self.isidle = True
        self.idle_key = None
        self.idle_frame = 0
        
        self.delay = milli
        self.tick = pygame.time.get_ticks() + self.delay
        self.ani_speed = 10
        
        self.keydown() #set values
        
      
    def Add(self,key,image):
        self.frames.setdefault(key,[]).append(image)
      
    def Animate(self,key, start=True):
        self.key = key
        
        if start is True:
            self.isidle = False
            self.tick = pygame.time.get_ticks() + self.delay
        else: #stop all animation and default to direction of key_up when stopped
            self.isidle = True
            self.Idle(self.key)
            
    def Animate2(self,key, start=True):
        self.key = key
        
        if start is True:
            self.isidle = False
            self.tick = pygame.time.get_ticks() + self.delay
            
        else: #stop all animation and default to direction of key_up when stopped
            self.isidle = True
            self.Idle(self.key)
        
      
    def Draw(self, surface):
        if self.isidle:
            surface.blit(self.frames[self.idle_key][self.idle_frame], (self.x, self.y))
        else:
            if pygame.time.get_ticks() > self.tick:
                self.tick += self.delay
                self.frame += 1
                if self.frame >= len(self.frames[self.key]): #if end of frames
                    self.frame = 0 #reset frames after full loop of animation
                    #self.isidle = True #return to idle after one loop animation
            surface.blit(self.frames[self.key][self.frame], (self.x, self.y))
         
    def Idle(self,key,framenumber=0):
        self.idle_key = key
        self.idle_frame = framenumber
        
    def loop_ani(self, key):
        pass
        
    def move(self, x,y):
        self.x += x
        self.y += y
        
    def check_move(self):
        movements = [self.up, self.down, self.right, self.left]
        keys = []
        for bewl in movements:
            if bewl is True:
                keys.append(bewl)
        if len(keys) > 1:
            one_keydown = True
        else:
            one_keydown = False
        
        if len(keys) == 1:
            '''if self.down and self.right:
                self.move(0,0)
            elif self.down and self.left:
                self.move(0,0)'''
            if self.down:
                self.move(0,1)
                self.right = False
                self.left = False
                self.up = False
    
                #self.Animate('front')
            #elif not self.down:
                #self.move(0,0)
                
            if self.up:
                self.move(0, -1)
            elif not self.up:
                self.move(0,0)
                
            if self.left:
                self.move(-1, 0)
            elif not self.left:
                self.move(0,0)
                
            if self.right:
                self.move(1,0)
            elif not self.right:
                self.move(0,0)
        
    def keydown(self, left=False, right=False,up=False,down=False):
        self.left = left
        self.right = right
        self.up = up
        self.down = down
        

class SpriteMovement(SpriteAnimated):
    def move(self, x=None,y=None):
        self.x += x
        self.y += y
        






def LoadImageAlpha(path, filename):
    p = os.path.join(os.getcwd(), path, filename)
    image = pygame.image.load(p)
    return image.convert_alpha()
      
def main():
    iPath = 'figure_position'
    screen = pygame.display.set_mode((800,600))
    #pygame.display.set_caption('Demo')
    clock = pygame.time.Clock()
   
    #char = SpriteMovement((50,50))
    char = SpriteAnimated((50,50))
   
    for iname in ['back','front','left','right']:
        for x in range(3):
            char.Add(iname, LoadImageAlpha(iPath, '{0}{1}.png'.format(iname, x)))   
   
    char.Idle('front') #default startup key
    movex, movey = 0,0
    test = 0
    Run = True
    while Run:
        keystate = pygame.key.get_pressed()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                Run = False
            elif event.type == pygame.KEYDOWN:
                test += 1
                
                if event.key in [pygame.K_s, pygame.K_DOWN, pygame.K_KP2]:
                    #char.move(0,5)
                    char.Animate('front')
                    char.down = True
                elif event.key in [pygame.K_w, pygame.K_UP, pygame.K_KP8]:
                    #char.move(0, -1)
                    char.Animate('back')
                    char.up = True
                elif event.key in [pygame.K_a, pygame.K_LEFT, pygame.K_KP4]:
                    #char.move(-1, 0)
                    char.Animate('left')
                    char.left = True
                elif event.key in [pygame.K_d, pygame.K_RIGHT, pygame.K_KP6]:
                    #char.move(1,0)
                    char.Animate('right')
                    char.right = True
            
            elif event.type == pygame.KEYUP:
                #char.move(0,0)
                if event.key in [pygame.K_s, pygame.K_DOWN, pygame.K_KP2]:
                    char.Animate('front', False)
                    char.down = False
                elif event.key in [pygame.K_w, pygame.K_UP, pygame.K_KP8]:
                    char.Animate('back', False)
                    char.up = False
                elif event.key in [pygame.K_a, pygame.K_LEFT, pygame.K_KP4]:
                    char.Animate('left', False)
                    char.left = False
                elif event.key in [pygame.K_d, pygame.K_RIGHT, pygame.K_KP6]:
                    char.Animate('right', False)
                    char.right = False
        
        char.check_move()
            
        screen.fill((0,0,0))
      
        char.Draw(screen)
        
        print('up: ', char.up)
        print('down: ', char.down)
        print('right: ',char.right)
        print('left: ', char.left)
        print()
        
        pygame.display.set_caption('coords: X:{} Y:{}'.format(char.x, char.y))
        pygame.display.update()
        clock.tick(30)
      
    pygame.quit()
   
if __name__ == '__main__':
    main()
    
    
    
    
    
    
    
    
    
    
    

    
